-- +----------------------------+     
-- |   Created and Produced by  |     
-- |    Hollow Horse Software   |
-- |          (C) 1997          |
-- +----------------------------+     
----------------------------------------------------------------------------
include image.e
--global function read_bitmap(sequence s)
  --return s
--end function

include rle.e
--global function SPT_to_RLE(sequence s)
  --return s
--end function

--global function RLE_to_SPT(sequence s)
  --return s
--end function

----------------------------------------------------------------------------
--Store the palettes & bitmaps
----------------------------------------------------------------------------

global function BMP_store1_0_0(sequence file, sequence list, sequence filenames)
  integer h, l, w
  sequence passed
  object x

  h = open(file, "wb")
  if h = -1 then
    puts(2, "Failed to open " & file)
    abort(0)
  end if

  --This is a filler because the
  puts(h, {0, 0})--number of bitmaps will be stored here
  puts(h, {0, 0} & "BMP")--version {0, 0} & "BMP"

  passed = {}
  for A = 1 to length(list) do
    x = list[A]--loaded bitmap

    if sequence(x) then--if bitmap loaded then
      passed = append(passed, filenames[A])--record bitmap was loaded
      x[1] = x[1] & repeat({0,0,0}, 256 - length(x[1]))

      l = length(x[2])--store bitmap length OR height
      puts(h, remainder(l, 256))
      puts(h, remainder(floor(l / 256), 256))

      w = length(x[2][1])--store bitmap width
      puts(h, remainder(w, 256))
      puts(h, remainder(floor(w / 256), 256))

      for B = 1 to 256 by 4 do--store bitmap palette
	puts(h, x[1][B])
	puts(h, x[1][B + 1])
	puts(h, x[1][B + 2])
	puts(h, x[1][B + 3])
      end for

      for B = 1 to l do--store bitmap
	puts(h, x[2][B])
      end for

    end if
  end for

  if machine_func(19, {h, 0}) then--seek to front of file
    puts(2, "File seek failed for " & file)
    abort(0)
  end if

  l = length(passed)--store number of bitmaps in file
  puts(h, remainder(l, 256))
  puts(h, remainder(floor(l / 256), 256))

  close(h)--close file
  return passed
end function
----------------------------------------------------------------------------
--Store the palettes & RLE compressed bitmaps
----------------------------------------------------------------------------

global function BMP_store1_1_0(sequence file, sequence list, sequence filenames)
  atom s
  integer h, l, w
  sequence passed, hold
  object x

  h = open(file, "wb")
  if h = -1 then
    puts(2, "Failed to open " & file)
    abort(0)
  end if

  --This is a filler because the
  puts(h, {0, 0})--number of bitmaps will be stored here
  puts(h, {1, 0} & "BMP")--version {0, 0} & "BMP"

  passed = {}
  for A = 1 to length(list) do
    x = list[A]--loaded bitmap

    if sequence(x) then--if bitmap loaded then
      passed = append(passed, filenames[A])--record bitmap was loaded
      x[1] = x[1] & repeat({0,0,0}, 256 - length(x[1]))

      l = length(x[2])--store bitmap length OR height
      w = length(x[2][1])--store bitmap width
      hold = repeat(0, l * w)

      s = 1
      for B = 1 to l do--store bitmap
	hold[s..s + w - 1] = x[2][B]
	s = s + w
      end for

      hold = SPT_to_RLE(hold)
      s = length(hold)      

      puts(h, remainder(s, 256))--store size
      s = floor(s / 256)
      puts(h, remainder(s, 256))
      s = floor(s / 256)
      puts(h, remainder(s, 256))
      s = floor(s / 256)
      puts(h, remainder(s, 256))
      puts(h, remainder(l, 256))--store length or height
      puts(h, remainder(floor(l / 256), 256))
      puts(h, remainder(w, 256))--store width
      puts(h, remainder(floor(w / 256), 256))

      for B = 1 to 256 by 4 do--store bitmap palette
	puts(h, x[1][B])
	puts(h, x[1][B + 1])
	puts(h, x[1][B + 2])
	puts(h, x[1][B + 3])
      end for

      puts(h, hold)--store RLE form of bitmap

    end if
  end for

  if machine_func(19, {h, 0}) then--seek to front of file
    puts(2, "File seek failed for " & file)
    abort(0)
  end if

  l = length(passed)--store number of bitmaps in file
  puts(h, remainder(l, 256))
  puts(h, remainder(floor(l / 256), 256))

  close(h)--close file
  return passed
end function
----------------------------------------------------------------------------
--Store RLE compressed palettes & bitmaps
----------------------------------------------------------------------------

global function BMP_store1(sequence file, sequence list, sequence filenames)
  atom s
  integer h, l, w
  sequence passed, hold
  object x

  h = open(file, "wb")
  if h = -1 then
    puts(2, "Failed to open " & file)
    abort(0)
  end if

  --This is a filler because the
  puts(h, {0, 0})--number of bitmaps will be stored here
  puts(h, {1, 1} & "BMP")--version {0, 0} & "BMP"

  passed = {}
  for A = 1 to length(list) do
    x = list[A]--loaded bitmap

    if sequence(x) then--if bitmap loaded then
      passed = append(passed, filenames[A])--record bitmap was loaded
      x[1] = x[1] & repeat({0,0,0}, 256 - length(x[1]))

      l = length(x[2])--store bitmap length OR height
      w = length(x[2][1])--store bitmap width
      hold = repeat(0, l * w + 768)

      s = 1
      for B = 1 to 256 by 2 do--store bitmap palette
	hold[s..s + 2] = x[1][B]
	s = s + 3
	hold[s..s + 2] = x[1][B + 1]
	s = s + 3
      end for

      for B = 1 to l do--store bitmap
	hold[s..s + w - 1] = x[2][B]
	s = s + w
      end for

      hold = SPT_to_RLE(hold)
      s = length(hold)      

      puts(h, remainder(s, 256))--store size
      s = floor(s / 256)
      puts(h, remainder(s, 256))
      s = floor(s / 256)
      puts(h, remainder(s, 256))
      s = floor(s / 256)
      puts(h, remainder(s, 256))
      puts(h, remainder(l, 256))--store length or height
      puts(h, remainder(floor(l / 256), 256))
      puts(h, remainder(w, 256))--store width
      puts(h, remainder(floor(w / 256), 256))

      puts(h, hold)--store RLE form of bitmap

    end if
  end for

  if machine_func(19, {h, 0}) then--seek to front of file
    puts(2, "File seek failed for " & file)
    abort(0)
  end if

  l = length(passed)--store number of bitmaps in file
  puts(h, remainder(l, 256))
  puts(h, remainder(floor(l / 256), 256))

  close(h)--close file
  return passed
end function
----------------------------------------------------------------------------
--Loads bitmaps and calls the storing feature
--which Stores the palettes & bitmaps
----------------------------------------------------------------------------

global function BMP_make1_0_0(sequence file, sequence filenames)
  integer l
  sequence list
  l = length(filenames)
  list = repeat(0, l)
  for A = 1 to l do
    list[A] = read_bitmap(filenames[A])
  end for
  return BMP_store1_0_0(file, list, filenames)
end function
----------------------------------------------------------------------------
--Loads bitmaps and calls the storing feature
--which Stores the palettes & RLE compressed bitmaps
----------------------------------------------------------------------------

global function BMP_make1_1_0(sequence file, sequence filenames)
  integer l
  sequence list
  l = length(filenames)
  list = repeat(0, l)
  for A = 1 to l do
    list[A] = read_bitmap(filenames[A])
  end for
  return BMP_store1_1_0(file, list, filenames)
end function
----------------------------------------------------------------------------
--Loads bitmaps and calls the storing feature
--which Stores RLE compressed palettes & bitmaps
----------------------------------------------------------------------------

global function BMP_make1(sequence file, sequence filenames)
  integer l
  sequence list
  l = length(filenames)
  list = repeat(0, l)
  for A = 1 to l do
    list[A] = read_bitmap(filenames[A])
  end for
  return BMP_store1(file, list, filenames)
end function
----------------------------------------------------------------------------

-- In Euphoria 2.1 this file (unless modified) is FREE - 0 statements.
with 23208238 -- delete this statement if it causes an error

