-------------------------------------
--DEMO OF MODE_19 GRAPHICS ENGINE  --
--Version 1.1
-------------------------------------
--BY MARK HONNOR 1997              --
-------------------------------------
--Optimized by James G. Harris     --
-------------------------------------

without type_check

include mode19.e --For Euphoria 1.5+
--include mode19a.e  --For Euphoria 2.0a+
include multibmp.e

object junk

sequence parallax_bg,nitrogen,sprites,tiles,main_pal,title_pal

sequence tile_dim   --size of the map tiles

nitrogen=BMP_load_all("all.mbm") --load bg and nitrogen background
parallax_bg =nitrogen[1]
main_pal=parallax_bg[1]
parallax_bg=Bmp2Mem(parallax_bg[2]) --stick bg in memory

tiles=SPRT_load_all("all.spt")
sprites=tiles[1..5]
sprites = Bmp2Mem(sprites)  --stick all 5 sprites in memory in one go.

nitrogen = nitrogen[2]
title_pal=nitrogen[1]
nitrogen=Bmp2Mem(nitrogen[2])   --stick the Liquid-Nitrogen logo in memory.

tiles=tiles[6..8]
tiles = Bmp2Mem(tiles)  --stick all 3 tiles in memory in one go.
tile_dim={20,20}


sequence map
map=rand(repeat(repeat(4,20),32))-1 --sets up a random map



---START OF MAIN CODE PART

junk=graphics_mode(19)  --set graphics mode to 320 x 200 x 256 colors

junk=set_screens(2)     --set up 2 virtual screens

all_palette(title_pal/4)    --set colors for first part of demo

fdisplay({0,0},nitrogen,2)  --display a 'background' on screen #2

sequence balls  --set up ball positions
integer max
max=8
balls=repeat({0,0,0,0},max)
for i = 1 to max do
    balls[i][1]=rand(320)-1
    balls[i][2]=rand(200)-1
end for


--FIRST PART OF DEMO: simple background and semi-transparent images

while get_key() != 27 do        --keep looping till Esc is pressed
    
    screen_copy(1,2)        --COPY THE BACKGROUND TO SCREEN #1

    --CONTROLL BALLS MOVEMENT
    --The balls will try to move toward the center point of the entire group
    --But as they move they cause the center to shift and they never stop,
    --to my current knowledge...
    for i = 1 to max do
    junk={0,0}
    for x = 1 to max do
        if x != i then
            junk=junk+(balls[x][1..2]-balls[i][1..2])
        end if
    end for

    --next: calculate the new velocity. It's raised to the power of 3
    --to keep it with the original sign (+ or -) and also
    --so that the more distance to move, the faster it will
    --move, this makes them move around more interestingly!!
    balls[i][3..4]=balls[i][3..4]+(power((junk/7),3)/10000000)
    
        --CONTROLL THE BALLS SPEEDS A LITTLE
        --So they don't go insane!!
        if balls[i][3]>3 then
            balls[i][3]=3
        end if
        if balls[i][4]>3 then
            balls[i][4]=3
        end if
        if balls[i][3]<-3 then
            balls[i][3]=-3
        end if
        if balls[i][4]<-3 then
            balls[i][4]=-3
        end if
        --Make sure the balls dont go off into space!
        balls[i][1..2]=balls[i][1..2]+balls[i][3..4]    --add velocity
        if balls[i][1]<-10 then
            balls[i][1]=319
        end if
        if balls[i][1]>319 then
            balls[i][1]=-10
        end if
        if balls[i][2]<-10 then
            balls[i][2]=199
        end if
        if balls[i][2]>199 then
            balls[i][2]=-10
        end if
        --draw ball
        display_clip(floor(balls[i][1..2]),sprites[remainder(i,2)+1],1)
    end for
    
------
  
        
-- this displays part of the background over the rest of the images!
    copy_region(2, {120, 103},{220,180}, 2, 1) 
    screen_copy(0,1)        --COPY SCREEN #1 TO THE REAL SCREEN
end while


--SECOND PART OF DEMO-- PARALLAX SCROLLER
--Flashing images and other exciting stuff ;)


procedure draw_bg(integer os)
  --this draws the background, and wraps around the left side to the right
  --side depending on what os is. Don't worry if you don't understand that ;)
  --the code is a bit complicated too, or maybe not, look for yerself!
    integer calc1, calc2
    calc1 = 320 - os
    for i = 0 to 199 do
        calc2 = i * 320
        mem_copy(screen[2]+(calc2)+os,screen[3]+(calc2),calc1)
        mem_copy(screen[2]+(calc2),screen[3]+(calc2)+calc1,os)
    end for
end procedure

procedure ud( sequence view)
--Updated all visable tiles to virtual screen number-1
--This is my basic scrolling tile engine.

--view is the position of the 'view window' which you can alter during your
--program ie. when the player moves around, to make the screen 'shake', etc..

--this procedure takes the images out of the sequence called tiles, you can
--call it something else if you want to, just change the names in here from
--tiles to what ever you want.

--and it figures out which tiles to draw by looking in the sequence map.
--map is a 2D sequence.

--tile_dim is a sequence containing the {x,y} dimensions of the tiles yer using

--the loops marked y_loop and x_loop must be altered depending on the tile size
--to make sure that the correct number of tiles are drawn to fill up the
--required amount of space, otherwise you get messy gaps at the edges or
--tiles off the edges which need not be drawn.

sequence temp,mov
integer y1, x1
    mov={remainder(view[1],tile_dim[1]),remainder(view[2],tile_dim[2])}
    temp=floor(view/tile_dim)
    for y = 0 to 10 do  --y_loop
        y1 = y + 1 + temp[2]
    for x = 0 to 16 do  --x_loop
        x1 = x + 1 + temp[1]
        if map[x1][y1]>0 then --only display a tile if its >0
            fdisplay_clip(({x,y}*tile_dim)-mov,tiles[map[x1][y1]],1)
        end if
    end for
    end for
end procedure


CLS(0,0)    --clear all the screens as well as the REAL SCREEN
CLS(1,0)
CLS(2,0)

all_palette(main_pal/4) --set the new colors

fdisplay({0,0},parallax_bg,2)   --display parallax_bg on Screen #2

sequence shots,man
shots=rand(repeat({320,200,1,1},10))-1 --holds the postitons of the fire balls
man=rand(repeat({320,1,1,1,1},2))-1 --holds the positions of the men.

sequence p  --p is the position of the 'view window' and its velosity
            --{x_pos,y_pox,x_vel,y_vel}
p={0,0,0,0}
while get_key() != 27 do    --keep looping untill Esc is pressed
        
        --On this part of the demo we don't need to copy the
        --'background' image to screen #1 because it needs to be done
        --differently because of the scrolling.. So it is done by
        --the draw_bg() procedure.
        
        --This section shifts the 'View Window' around.
        --The view tries to accelerate itself toward the center of the map
        --but then over shoots the middle and turns around. And so on...
        if p[1]<160 then
            p[3]=p[3]+rand(5)
        end if
        if p[2]<100 then
            p[4]=p[4]+rand(5)
        end if
        if p[1]>160 then
            p[3]=p[3]-rand(5)
        end if
        if p[2]>100 then
            p[4]=p[4]-rand(5)
        end if
        
        p[1..2]=p[1..2]+(p[3..4]/20)    --add the view points velocity to
                                        --its position to move it around.
        if p[1]<0 then
            p[1]=0
        end if
        if p[2]<0 then
            p[2]=0
        end if
        if p[1]>319 then
            p[1]=319
        end if
        if p[2]>199 then
            p[2]=199
        end if
        ---------------end of view shifting
        
        draw_bg(320-floor(p[1]/2))  --draw the far background -ie the mushrooms.
        ud(p[1..2])                 --draw the close background - ie the tiles.
        
        
        --now we move the fireballs around
        for i = 1 to 10 do
            if shots[i][1]<160 then
                shots[i][3]=shots[i][3]+rand(5)
            end if
            if shots[i][2]<100 then
                shots[i][4]=shots[i][4]+rand(5)
            end if
            if shots[i][1]>160 then
                shots[i][3]=shots[i][3]-rand(5)
            end if
            if shots[i][2]>100 then
                shots[i][4]=shots[i][4]-rand(5)
            end if
            shots[i][1..2]=shots[i][1..2]+(shots[i][3..4]/20)--add velocity
            if shots[i][1]<0 then
                shots[i][1]=0
            end if
            if shots[i][2]<0 then
                shots[i][2]=0
            end if
            if shots[i][1]>319 then
                shots[i][1]=319
            end if
            if shots[i][2]>199 then
                shots[i][2]=199
            end if
            display_clip(floor(shots[i][1..2]),sprites[3],1)
        end for
        
        --Now we move the men around.
        --They sway left to right, and bounce off the floor.
        for i = 1 to 2 do
            man[i][4]=man[i][4]+.2  --add gravity to the mans vertical velocity
            if man[i][1]<160 then
                man[i][3]=man[i][3]+rand(6)
            end if
            if man[i][1]>160 then
                man[i][3]=man[i][3]-rand(6)
            end if
            man[i][1..2]=man[i][1..2]+(man[i][3..4]/{5,1})  --add velocity
                                                --x velocity is divided by 5
                                                --so it doesn't move around
                                                --too fast.
            if man[i][1]<-10 then
                man[i][1]=-10
            end if
            if man[i][1]>300 then
                man[i][1]=300
            end if
            if man[i][2]>180 then
                man[i][2]=180
                man[i][4]=-rand(5)-5    --make the man bounce back upwards
            end if
        end for
        
        --now  we check if the shots hit the men
        for i = 1 to 10 do
            for m = 1 to 2  do
            junk=shots[i][1..2]-(man[m][1..2]+{10,15})--get vector distance
                                                      --as a sequence.
            junk=sqrt((junk[1]*junk[1])+(junk[2]*junk[2]))--get actual distance
                                                          --as a single number
            if junk-15<0 then   --check if the distance is small enough for
                                --the fireball to touch the man.
                man[m][5]=man[m][5]+3
            end if
        end for
        end for
    
        --now we draw the men and make them flash if they are hit.
        for i = 1 to 2 do
            if man[i][5]>0 then
                man[i][5]=man[i][5]-1   --decrease the amount of 'flashing'
                                        --this man has left on him.
            end if
            if remainder(man[i][5]+1,3) then --if he's not flashing or he is
                                             --flashing back to normal
                                             --then display the normal picture
                display_clip(man[i][1..2],sprites[i+3],1)
            else                            --if he is flashing then draw him
                                            --colored in white (255)
                cdisplay_clip(man[i][1..2],sprites[i+3],255,1)
            end if
        end for
    
    screen_copy(0,1)--display the contents of the 'frame' to the REAL SCREEN.
end while

junk=graphics_mode(-1)  --restore graphics mode to normal.
puts(1,"                        Mode_19 Graphics Demo.\n")
puts(1,"                          Copyright (c) 1997.\n")
puts(1,"                Liquid-Nitrogen Software (aka Mark Honnor).\n")
puts(1,"                          All Rights Reserved.\n\n")
puts(1,"                      E-Mail: nitrogen@xtra.co.nz\n\n")

