without type_check
include pal.e
include pal2.e
include graphics.e

clear_screen()
puts(1, "255 Color shifting benchmark\n")
puts(1, "This will benchmark standard Euphoria and custom palette routines.\n")
puts(1, "\nThis may take a few minutes. Press a key to continue.\n")

while get_key() = -1 do
end while

function custom_palette()
    sequence pal
    pal = repeat({0,0,0},256)
    for x = 0 to 63 do
        --set up grays
        pal[x+1]  = {x,x,x} 
        --set up reds 
        pal[x+65] = {x,0,0}
        --set up greens
        pal[x+129]= {0,x,0}
        --set up blues
        pal[x+193] ={0,0,x} 
    end for
    all_palette(pal)
    return pal
end function

sequence temp, temp2, temppal
object junk, junk2 
atom t, t2, t3, t4
 
if (graphics_mode(19) =-1) then 
    puts(2, "Can't set graphics mode 19!\n")
    abort(1)
else
end if

temp = custom_palette() -- set up palette and install default
temppal = temp & temp   -- set up double palette for fast rotation

for x = 0 to 320 do  -- draw 320 lines
    draw_line(x,{{x,0},{x,199}})
end for

tick_rate(100)   -- get timing a little better

junk2 = get_palette1(0) --use to reset palette values

t = time()       -- Euphoria palette routine
    for x = 0 to 254 do
        temp2 = get_palette(x+1) --Use this to get the palette colors (NE)
        junk = palette(x, temp2)
    end for
t = time() - t    
junk = palette(255, junk2) -- restore palette

t2 = time()
    for x = 0 to 254 do -- Pal.e routines
        temp2 = get_palette(x+1)
        set_palette(x, temp2)
    end for
t2 = time() - t2    
junk = palette(255, junk2) -- restore palette
    

t3 = time()
    for x = 0 to 254 do -- Pal2.e routines
        temp2 = get_palette1(x+1)
        set_palette1(x, temp2)
    end for
t3 = time() - t3    
junk = palette(255, junk2) -- restore palette


t4 = time() 
       all_palette(temppal[2..257])  --using double palette for speed
t4 = time() - t4

if graphics_mode(-1) then end if

clear_screen()
puts(1, "Shifting 255 palette entries 1X results at tick_rate(100).\n\n")
printf(1, "Using Euphoria's palette command: %.7f seconds.\n", t)
printf(1, "Using Pal.e (dos interrupts): %.7f seconds.\n", t2)
printf(1, "Using Pal2.e (VGA port calls): %.7f seconds.\n", t3)
printf(1, "Using standard All_palette with double palette: %.7f seconds.\n", t4)

